Index: LMDZ5/branches/testing/libf/phylmd/sw_aeroAR4.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/sw_aeroAR4.F90	(revision 1665)
+++ LMDZ5/branches/testing/libf/phylmd/sw_aeroAR4.F90	(revision 1669)
@@ -18,8 +18,8 @@
      PSOLSWAERO,PSOLSW0AERO,&
      PTOPSWCFAERO,PSOLSWCFAERO,&
-     ok_ade, ok_aie )
+     ok_ade, ok_aie, flag_aerosol )
 
   USE dimphy
-
+  USE phys_output_mod, ONLY : swaero_diag
   IMPLICIT NONE
 
@@ -56,7 +56,8 @@
   !     --------------
   !        ORIGINAL : 89-07-14
-  !        95-01-01   J.-J. MORCRETTE  Direct/Diffuse Albedo
-  !        03-11-27   J. QUAAS Introduce aerosol forcings (based on BOUCHER)
-  !        09-04      A. COZIC - C.DEANDREIS Indroduce NAT/BC/POM/DUST/SS aerosol forcing
+  !        1995-01-01  J.-J. MORCRETTE  Direct/Diffuse Albedo
+  !        2003-11-27  J. QUAAS Introduce aerosol forcings (based on BOUCHER)
+  !        2009-04     A. COZIC - C.DEANDREIS Indroduce NAT/BC/POM/DUST/SS aerosol forcing
+  !        2012-09     O. BOUCHER - reorganise aerosol cases with ok_ade, ok_aie, flag_aerosol
   !     ------------------------------------------------------------------
   !
@@ -82,5 +83,5 @@
 
   REAL(KIND=8) PCLDSW(KDLON,KFLEV)    ! CLOUD FRACTION
-  REAL(KIND=8) PTAU(KDLON,2,KFLEV)    ! CLOUD OPTICAL THICKNESS
+  REAL(KIND=8) PTAU(KDLON,2,KFLEV)    ! CLOUD OPTICAL THICKNESS (pre-industrial value)
   REAL(KIND=8) PCG(KDLON,2,KFLEV)     ! ASYMETRY FACTOR
   REAL(KIND=8) POMEGA(KDLON,2,KFLEV)  ! SINGLE SCATTERING ALBEDO
@@ -132,24 +133,25 @@
   !$OMP THREADPRIVATE(initialized)
 
-  !jq-Introduced for aerosol forcings
+  !jq-local flag introduced for aerosol forcings
   REAL(KIND=8), SAVE :: flag_aer
   !$OMP THREADPRIVATE(flag_aer)
 
   LOGICAL ok_ade, ok_aie    ! use aerosol forcings or not?
+  INTEGER flag_aerosol      ! global flag for aerosol 0 (no aerosol) or 1-5 (aerosols)
   REAL(KIND=8) tauaero(kdlon,kflev,9,2)  ! aerosol optical properties
   REAL(KIND=8) pizaero(kdlon,kflev,9,2)  ! (see aeropt.F)
   REAL(KIND=8) cgaero(kdlon,kflev,9,2)   ! -"-
-  REAL(KIND=8) PTAUA(KDLON,2,KFLEV)    ! CLOUD OPTICAL THICKNESS (pre-industrial value)
+  REAL(KIND=8) PTAUA(KDLON,2,KFLEV)    ! CLOUD OPTICAL THICKNESS (present-day value)
   REAL(KIND=8) POMEGAA(KDLON,2,KFLEV)  ! SINGLE SCATTERING ALBEDO
   REAL(KIND=8) PTOPSWADAERO(KDLON)     ! SHORTWAVE FLUX AT T.O.A.(+AEROSOL DIR)
   REAL(KIND=8) PSOLSWADAERO(KDLON)     ! SHORTWAVE FLUX AT SURFACE(+AEROSOL DIR)
-  REAL(KIND=8) PTOPSWAD0AERO(KDLON)     ! SHORTWAVE FLUX AT T.O.A.(+AEROSOL DIR)
-  REAL(KIND=8) PSOLSWAD0AERO(KDLON)     ! SHORTWAVE FLUX AT SURFACE(+AEROSOL DIR)
+  REAL(KIND=8) PTOPSWAD0AERO(KDLON)    ! SHORTWAVE FLUX AT T.O.A.(+AEROSOL DIR)
+  REAL(KIND=8) PSOLSWAD0AERO(KDLON)    ! SHORTWAVE FLUX AT SURFACE(+AEROSOL DIR)
   REAL(KIND=8) PTOPSWAIAERO(KDLON)     ! SHORTWAVE FLUX AT T.O.A.(+AEROSOL IND)
   REAL(KIND=8) PSOLSWAIAERO(KDLON)     ! SHORTWAVE FLUX AT SURFACE(+AEROSOL IND)
-  REAL(KIND=8) PTOPSWAERO(KDLON,9)	 ! SW TOA AS DRF nat & ant 
-  REAL(KIND=8) PTOPSW0AERO(KDLON,9)	 ! SW SRF AS DRF nat & ant 
-  REAL(KIND=8) PSOLSWAERO(KDLON,9)	 ! SW TOA CS DRF nat & ant
-  REAL(KIND=8) PSOLSW0AERO(KDLON,9)	 ! SW SRF CS DRF nat & ant
+  REAL(KIND=8) PTOPSWAERO(KDLON,9)     ! SW TOA AS DRF nat & ant 
+  REAL(KIND=8) PTOPSW0AERO(KDLON,9)    ! SW SRF AS DRF nat & ant 
+  REAL(KIND=8) PSOLSWAERO(KDLON,9)     ! SW TOA CS DRF nat & ant
+  REAL(KIND=8) PSOLSW0AERO(KDLON,9)    ! SW SRF CS DRF nat & ant
   REAL(KIND=8) PTOPSWCFAERO(KDLON,3)   !  SW TOA AS cloudRF nat & ant 
   REAL(KIND=8) PSOLSWCFAERO(KDLON,3)   !  SW SRF AS cloudRF nat & ant 
@@ -179,24 +181,13 @@
 
 ! Key to define the aerosol effect acting on climate
-! 0: aerosol feedback active according to ok_ade, ok_aie  DEFAULT 
-! 1: no feedback , zero aerosol fluxes are used for climate, diagnostics according to ok_ade_ok_aie
-! 2: feedback according to total aerosol direct effect used for climate, diagnostics according to ok_ade, ok_aie
-! 3: feedback according to natural aerosol direct effect used for climate, diagnostics according to ok_ade_ok_aie
-
-  INTEGER,SAVE :: AEROSOLFEEDBACK_ACTIVE = 0
+! OB: AEROSOLFEEDBACK_ACTIVE is now a LOGICAL
+! TRUE: fluxes use natural and/or anthropogenic aerosols according to ok_ade and ok_aie, DEFAULT
+! FALSE: fluxes use no aerosols (case 1)
+
+  LOGICAL,SAVE :: AEROSOLFEEDBACK_ACTIVE = .TRUE.
 !$OMP THREADPRIVATE(AEROSOLFEEDBACK_ACTIVE)  
 
       CHARACTER (LEN=20) :: modname='sw_aeroAR4'
       CHARACTER (LEN=80) :: abort_message
-
-  IF ((.not. ok_ade) .and. (AEROSOLFEEDBACK_ACTIVE .ge. 2)) THEN
-     abort_message ='Error: direct effect is not activated but assumed to be active - see sw_aeroAR4.F90'
-     CALL abort_gcm (modname,abort_message,1)
-  ENDIF
-  AEROSOLFEEDBACK_ACTIVE=MIN(MAX(AEROSOLFEEDBACK_ACTIVE,0),3)
-  IF  (AEROSOLFEEDBACK_ACTIVE .gt. 3) THEN
-     abort_message ='Error: AEROSOLFEEDBACK_ACTIVE options go only until 3'
-     CALL abort_gcm (modname,abort_message,1)
-  ENDIF
 
   IF(.NOT.initialized) THEN
@@ -209,8 +200,25 @@
      ALLOCATE(ZFSUPAI_AERO(KDLON,KFLEV+1))
      ALLOCATE(ZFSDNAI_AERO(KDLON,KFLEV+1))
-     ALLOCATE(ZFSUP_AERO (KDLON,KFLEV+1,9))
-     ALLOCATE(ZFSDN_AERO (KDLON,KFLEV+1,9))
-     ALLOCATE(ZFSUP0_AERO(KDLON,KFLEV+1,9))
-     ALLOCATE(ZFSDN0_AERO(KDLON,KFLEV+1,9))
+!-OB decrease size of these arrays to what is needed
+!                | direct effect 
+!ind effect      | no aerosol   natural  total
+!natural (PTAU)  |   1            3       2     --ZFSUP/ZFSDN
+!total (PTAUA)   |                5       4     --ZFSUP/ZFSDN
+!no cloud        |   1            3       2     --ZFSUP0/ZFSDN0
+! so we need which case when ? 
+! ok_ade and ok_aie = 4-5, 4-2 and 2 
+! ok_ade and not ok_aie = 2-3 and 2 
+! not ok_ade and ok_aie = 5-3 and 5 
+! not ok_ade and not ok_aie = 3 
+! therefore the cases have the folliwng switches 
+! 3 = not ok_ade or not ok_aie 
+! 4 = ok_ade and ok_aie 
+! 2 = ok_ade 
+! 5 = ok_aie 
+     ALLOCATE(ZFSUP_AERO (KDLON,KFLEV+1,5))
+     ALLOCATE(ZFSDN_AERO (KDLON,KFLEV+1,5))
+     ALLOCATE(ZFSUP0_AERO(KDLON,KFLEV+1,3))
+     ALLOCATE(ZFSDN0_AERO(KDLON,KFLEV+1,3))
+! end OB modif
      ZFSUPAD_AERO(:,:)=0.
      ZFSDNAD_AERO(:,:)=0.
@@ -226,5 +234,5 @@
 
   IF (appel1er) THEN
-     WRITE(lunout,*) 'SW calling frequency : ', swpas
+     WRITE(lunout,*)'SW calling frequency : ', swpas
      WRITE(lunout,*) "   In general, it should be 1"
      appel1er = .FALSE.
@@ -241,6 +249,6 @@
      ENDDO
 
-! clear sky is either computed IF no direct effect is asked for, or for extended diag) 
-     IF (( lev_histmth .ge. 4 ) .or. ( .not. ok_ade )) THEN    
+! clear sky with no aerosols at all is computed IF ACTIVEFEEDBACK_ACTIVE is false or for extended diag
+     IF ( swaero_diag .or. .not. AEROSOLFEEDBACK_ACTIVE .OR. flag_aerosol .EQ. 0 ) THEN    
 
      ! clear-sky: zero aerosol effect
@@ -268,8 +276,8 @@
         ENDDO
      ENDDO
-     ENDIF
-
-! cloudy sky is either computed IF no indirect effect is asked for, or for extended diag) 
-     IF (( lev_histmth .ge. 4 ) .or. ( .not. ok_aie )) THEN    
+     ENDIF ! swaero_diag .or. .not. AEROSOLFEEDBACK_ACTIVE
+
+! cloudy sky with no aerosols at all is either computed IF no indirect effect is asked for, or for extended diag
+     IF ( swaero_diag .or. .not. AEROSOLFEEDBACK_ACTIVE .OR. flag_aerosol .EQ. 0 ) THEN    
      ! cloudy-sky: zero aerosol effect
      flag_aer=0.0
@@ -297,10 +305,41 @@
         ENDDO
      ENDDO
-     ENDIF
-
+     ENDIF ! swaero_diag .or. .not. AEROSOLFEEDBACK_ACTIVE
+
+     IF (flag_aerosol .GT. 0 ) THEN
+
+     IF (ok_ade.and.swaero_diag .or. .not. ok_ade) THEN
+
+        ! clear sky direct effect natural aerosol
+        ! CAS AER (3)
+        flag_aer=1.0
+        CALL SWU_LMDAR4(PSCT,ZCLDSW0,PPMB,PPSOL,&
+             PRMU0,PFRAC,PTAVE,PWV,&
+             ZAKI,ZCLD,ZCLEAR,ZDSIG,ZFACT,ZRMU,ZSEC,ZUD)
+        INU = 1
+        CALL SW1S_LMDAR4(INU, PAER, flag_aer,&
+             tauaero(:,:,3,:), pizaero(:,:,3,:), cgaero(:,:,3,:),&
+             PALBD, PALBP, PCG, ZCLD, ZCLEAR, PCLDSW,&
+             ZDSIG, POMEGA, ZOZ, ZRMU, ZSEC, PTAU, ZUD,&
+             ZFD, ZFU)
+        INU = 2
+        CALL SW2S_LMDAR4(INU, PAER, flag_aer,&
+             tauaero(:,:,3,:), pizaero(:,:,3,:), cgaero(:,:,3,:),&
+             ZAKI, PALBD, PALBP, PCG, ZCLD, ZCLEAR, PCLDSW,&
+             ZDSIG, POMEGA, ZOZ, ZRMU, ZSEC, PTAU, ZUD,&
+             PWV, PQS,&
+             ZFDOWN, ZFUP)
+
+        DO JK = 1 , KFLEV+1
+           DO JL = 1, KDLON
+              ZFSUP0_AERO(JL,JK,3) = (ZFUP(JL,JK)   + ZFU(JL,JK)) * ZFACT(JL)
+              ZFSDN0_AERO(JL,JK,3) = (ZFDOWN(JL,JK) + ZFD(JL,JK)) * ZFACT(JL)
+           ENDDO
+        ENDDO
+     ENDIF !--end not swaero_diag or not ok_ade
 
      IF (ok_ade) THEN
 
-        ! clear sky (Anne Cozic 03/07/2007) direct effect of total aerosol
+        ! clear sky direct effect of total aerosol
         ! CAS AER (2)
         flag_aer=1.0
@@ -329,7 +368,8 @@
         ENDDO
 
-! cloudy sky is either computed IF no indirect effect is asked for, or for extended diag) 
-        IF (( lev_histmth .ge. 2 ) .or. (.not. ok_aie)) THEN  
-        ! cloudy-sky aerosol direct effect of total aerosol
+        ! cloudy-sky with natural aerosols for indirect effect 
+        ! but total aerosols for direct effect
+        ! PTAU
+        ! CAS AER (2)
         flag_aer=1.0
         CALL SWU_LMDAR4(PSCT,PCLDSW,PPMB,PPSOL,&
@@ -356,37 +396,13 @@
            ENDDO
         ENDDO
-        ENDIF
-
-! natural aeroosl clear sky is  computed  for extended diag) 
-        IF ( lev_histmth .ge. 4 ) THEN            
-        ! clear sky direct effect natural aerosol
-        flag_aer=1.0
-        CALL SWU_LMDAR4(PSCT,ZCLDSW0,PPMB,PPSOL,&
-             PRMU0,PFRAC,PTAVE,PWV,&
-             ZAKI,ZCLD,ZCLEAR,ZDSIG,ZFACT,ZRMU,ZSEC,ZUD)
-        INU = 1
-        CALL SW1S_LMDAR4(INU, PAER, flag_aer,&
-             tauaero(:,:,3,:), pizaero(:,:,3,:), cgaero(:,:,3,:),&
-             PALBD, PALBP, PCG, ZCLD, ZCLEAR, PCLDSW,&
-             ZDSIG, POMEGA, ZOZ, ZRMU, ZSEC, PTAU, ZUD,&
-             ZFD, ZFU)
-        INU = 2
-        CALL SW2S_LMDAR4(INU, PAER, flag_aer,&
-             tauaero(:,:,3,:), pizaero(:,:,3,:), cgaero(:,:,3,:),&
-             ZAKI, PALBD, PALBP, PCG, ZCLD, ZCLEAR, PCLDSW,&
-             ZDSIG, POMEGA, ZOZ, ZRMU, ZSEC, PTAU, ZUD,&
-             PWV, PQS,&
-             ZFDOWN, ZFUP)
-
-        DO JK = 1 , KFLEV+1
-           DO JL = 1, KDLON
-              ZFSUP0_AERO(JL,JK,3) = (ZFUP(JL,JK)   + ZFU(JL,JK)) * ZFACT(JL)
-              ZFSDN0_AERO(JL,JK,3) = (ZFDOWN(JL,JK) + ZFD(JL,JK)) * ZFACT(JL)
-           ENDDO
-        ENDDO
-        ENDIF
-
-! cloud sky natural is for extended diagnostics
-        IF ( lev_histmth .ge. 2 ) THEN
+
+     ENDIF !-end ok_ade
+
+     IF ( .not. ok_ade .or. .not. ok_aie ) THEN
+
+        ! cloudy-sky with natural aerosols for indirect effect 
+        ! and natural aerosols for direct effect
+        ! PTAU
+        ! CAS AER (3)
         ! cloudy-sky direct effect natural aerosol
         flag_aer=1.0
@@ -414,11 +430,13 @@
            ENDDO
         ENDDO
-        ENDIF
-
-     ENDIF ! ok_ade
-
-! cloudy sky needs to be computed in all cases IF ok_aie is activated
-     IF (ok_aie) THEN
-        !jq   cloudy-sky + aerosol direct + aerosol indirect of total aerosol
+
+     ENDIF  !--true/false or false/true
+
+     IF (ok_ade .and. ok_aie) THEN
+
+        ! cloudy-sky with total aerosols for indirect effect 
+        ! and total aerosols for direct effect
+        ! PTAUA
+        ! CAS AER (2)
         flag_aer=1.0
         CALL SWU_LMDAR4(PSCT,PCLDSW,PPMB,PPSOL,&
@@ -438,4 +456,5 @@
              PWV, PQS,&
              ZFDOWN, ZFUP)
+
         DO JK = 1 , KFLEV+1
            DO JL = 1, KDLON
@@ -444,11 +463,46 @@
            ENDDO
         ENDDO
+  
+      ENDIF ! ok_ade .and. ok_aie
+
+     IF (ok_aie) THEN
+        ! cloudy-sky with total aerosols for indirect effect 
+        ! and natural aerosols for direct effect
+        ! PTAUA
+        ! CAS AER (3)
+        flag_aer=1.0
+        CALL SWU_LMDAR4(PSCT,PCLDSW,PPMB,PPSOL,&
+             PRMU0,PFRAC,PTAVE,PWV,&
+             ZAKI,ZCLD,ZCLEAR,ZDSIG,ZFACT,ZRMU,ZSEC,ZUD)
+        INU = 1
+        CALL SW1S_LMDAR4(INU, PAER, flag_aer,&
+             tauaero(:,:,3,:), pizaero(:,:,3,:), cgaero(:,:,3,:),&
+             PALBD, PALBP, PCG, ZCLD, ZCLEAR, PCLDSW,&
+             ZDSIG, POMEGAA, ZOZ, ZRMU, ZSEC, PTAUA, ZUD,&
+             ZFD, ZFU)
+        INU = 2
+        CALL SW2S_LMDAR4(INU, PAER, flag_aer,&
+             tauaero(:,:,3,:), pizaero(:,:,3,:), cgaero(:,:,3,:),&
+             ZAKI, PALBD, PALBP, PCG, ZCLD, ZCLEAR, PCLDSW,&
+             ZDSIG, POMEGAA, ZOZ, ZRMU, ZSEC, PTAUA, ZUD,&
+             PWV, PQS,&
+             ZFDOWN, ZFUP)
+  
+        DO JK = 1 , KFLEV+1
+           DO JL = 1, KDLON
+              ZFSUP_AERO(JL,JK,5) = (ZFUP(JL,JK)   + ZFU(JL,JK)) * ZFACT(JL)
+              ZFSDN_AERO(JL,JK,5) = (ZFDOWN(JL,JK) + ZFD(JL,JK)) * ZFACT(JL) 
+           ENDDO
+        ENDDO
+
      ENDIF ! ok_aie      
 
+     ENDIF !--if flag_aerosol GT 0
+
      itapsw = 0
   ENDIF
   itapsw = itapsw + 1
 
-  IF  ( AEROSOLFEEDBACK_ACTIVE .eq. 0) THEN
+  IF  ( AEROSOLFEEDBACK_ACTIVE .AND. flag_aerosol .GT. 0 ) THEN
   IF ( ok_ade .and. ok_aie  ) THEN
     ZFSUP(:,:) =    ZFSUP_AERO(:,:,4)
@@ -457,4 +511,5 @@
     ZFSDN0(:,:) =   ZFSDN0_AERO(:,:,2)
   ENDIF
+
   IF ( ok_ade .and. (.not. ok_aie) )  THEN
     ZFSUP(:,:) =    ZFSUP_AERO(:,:,2)
@@ -465,11 +520,21 @@
 
   IF ( (.not. ok_ade) .and. ok_aie  )  THEN
-    print*,'Warning: indirect effect in cloudy regions includes direct aerosol effect'
-    ZFSUP(:,:) =    ZFSUP_AERO(:,:,4)
-    ZFSDN(:,:) =    ZFSDN_AERO(:,:,4)
-    ZFSUP0(:,:) =   ZFSUP0_AERO(:,:,1)
-    ZFSDN0(:,:) =   ZFSDN0_AERO(:,:,1)
-  ENDIF
+    ZFSUP(:,:) =    ZFSUP_AERO(:,:,5)
+    ZFSDN(:,:) =    ZFSDN_AERO(:,:,5)
+    ZFSUP0(:,:) =   ZFSUP0_AERO(:,:,3)
+    ZFSDN0(:,:) =   ZFSDN0_AERO(:,:,3)
+  ENDIF
+
   IF ((.not. ok_ade) .and. (.not. ok_aie)) THEN
+    ZFSUP(:,:) =    ZFSUP_AERO(:,:,3)
+    ZFSDN(:,:) =    ZFSDN_AERO(:,:,3)
+    ZFSUP0(:,:) =   ZFSUP0_AERO(:,:,3)
+    ZFSDN0(:,:) =   ZFSDN0_AERO(:,:,3)
+  ENDIF
+
+! MS the following allows to compute the forcing diagostics without
+! letting the aerosol forcing act on the meteorology
+! SEE logic above
+  ELSE 
     ZFSUP(:,:) =    ZFSUP_AERO(:,:,1)
     ZFSDN(:,:) =    ZFSDN_AERO(:,:,1)
@@ -478,15 +543,5 @@
   ENDIF
 
-! MS the following allows to compute the forcing diagostics without
-! letting the aerosol forcing act on the meteorology
-! SEE logic above
-  ELSEIF  ( AEROSOLFEEDBACK_ACTIVE .gt. 0) THEN
-    ZFSUP(:,:) =    ZFSUP_AERO(:,:,AEROSOLFEEDBACK_ACTIVE)
-    ZFSDN(:,:) =    ZFSDN_AERO(:,:,AEROSOLFEEDBACK_ACTIVE)
-    ZFSUP0(:,:) =   ZFSUP0_AERO(:,:,AEROSOLFEEDBACK_ACTIVE)
-    ZFSDN0(:,:) =   ZFSDN0_AERO(:,:,AEROSOLFEEDBACK_ACTIVE)
-  ENDIF
-  
-
+! Now computes heating rates
   DO k = 1, KFLEV
      kpl1 = k+1
@@ -511,24 +566,33 @@
      PTOPSW(i) = ZFSDN(i,KFLEV+1) - ZFSUP(i,KFLEV+1)
 
-
 ! net anthropogenic forcing direct and 1st indirect effect diagnostics
 ! requires a natural aerosol field read and used 
 ! Difference of net fluxes from double call to radiation
 
-
 IF (ok_ade) THEN
 
 ! indices 1: natural; 2 anthropogenic 
+
 ! TOA/SRF all sky natural forcing
      PSOLSWAERO(i,1) = (ZFSDN_AERO(i,1,3) - ZFSUP_AERO(i,1,3))-(ZFSDN_AERO(i,1,1) - ZFSUP_AERO(i,1,1))
      PTOPSWAERO(i,1) = (ZFSDN_AERO(i,KFLEV+1,3) - ZFSUP_AERO(i,KFLEV+1,3))- (ZFSDN_AERO(i,KFLEV+1,1) - ZFSUP_AERO(i,KFLEV+1,1))
 
+! TOA/SRF clear sky natural forcing
+     PSOLSW0AERO(i,1) = (ZFSDN0_AERO(i,1,3) - ZFSUP0_AERO(i,1,3))-(ZFSDN0_AERO(i,1,1) - ZFSUP0_AERO(i,1,1))
+     PTOPSW0AERO(i,1) = (ZFSDN0_AERO(i,KFLEV+1,3) - ZFSUP0_AERO(i,KFLEV+1,3))-(ZFSDN0_AERO(i,KFLEV+1,1) - ZFSUP0_AERO(i,KFLEV+1,1))
+
+   IF (ok_aie) THEN 
+
+! TOA/SRF all sky anthropogenic forcing
+     PSOLSWAERO(i,2) = (ZFSDN_AERO(i,1,4) - ZFSUP_AERO(i,1,4))-(ZFSDN_AERO(i,1,5) - ZFSUP_AERO(i,1,5))
+     PTOPSWAERO(i,2) = (ZFSDN_AERO(i,KFLEV+1,4) - ZFSUP_AERO(i,KFLEV+1,4))- (ZFSDN_AERO(i,KFLEV+1,5) - ZFSUP_AERO(i,KFLEV+1,5))
+
+   ELSE 
+
 ! TOA/SRF all sky anthropogenic forcing
      PSOLSWAERO(i,2) = (ZFSDN_AERO(i,1,2) - ZFSUP_AERO(i,1,2))-(ZFSDN_AERO(i,1,3) - ZFSUP_AERO(i,1,3))
      PTOPSWAERO(i,2) = (ZFSDN_AERO(i,KFLEV+1,2) - ZFSUP_AERO(i,KFLEV+1,2))- (ZFSDN_AERO(i,KFLEV+1,3) - ZFSUP_AERO(i,KFLEV+1,3))
 
-! TOA/SRF clear sky natural forcing
-     PSOLSW0AERO(i,1) = (ZFSDN0_AERO(i,1,3) - ZFSUP0_AERO(i,1,3))-(ZFSDN0_AERO(i,1,1) - ZFSUP0_AERO(i,1,1))
-     PTOPSW0AERO(i,1) = (ZFSDN0_AERO(i,KFLEV+1,3) - ZFSUP0_AERO(i,KFLEV+1,3))-(ZFSDN0_AERO(i,KFLEV+1,1) - ZFSUP0_AERO(i,KFLEV+1,1))
+   ENDIF
 
 ! TOA/SRF clear sky anthropogenic forcing
@@ -536,4 +600,11 @@
      PTOPSW0AERO(i,2) = (ZFSDN0_AERO(i,KFLEV+1,2) - ZFSUP0_AERO(i,KFLEV+1,2))-(ZFSDN0_AERO(i,KFLEV+1,3) - ZFSUP0_AERO(i,KFLEV+1,3))
 
+! direct anthropogenic forcing , as in old LMDzT, however differences of net fluxes
+     PSOLSWADAERO(i) = PSOLSWAERO(i,2)
+     PTOPSWADAERO(i) = PTOPSWAERO(i,2)
+     PSOLSWAD0AERO(i) = PSOLSW0AERO(i,2)
+     PTOPSWAD0AERO(i) = PTOPSW0AERO(i,2)
+
+! OB: these diagnostics may not always work but who need them
 ! Cloud forcing indices 1: natural; 2 anthropogenic; 3: zero aerosol direct effect
 ! Instantaneously computed cloudy sky direct aerosol effect, cloud forcing due to aerosols above clouds
@@ -552,18 +623,17 @@
      PTOPSWCFAERO(i,3) = (ZFSDN_AERO(i,KFLEV+1,1) - ZFSUP_AERO(i,KFLEV+1,1))- (ZFSDN0_AERO(i,KFLEV+1,1) - ZFSUP0_AERO(i,KFLEV+1,1))
 
-! direct anthropogenic forcing , as in old LMDzT, however differences of net fluxes
-     PSOLSWADAERO(i) = PSOLSWAERO(i,2)
-     PTOPSWADAERO(i) = PTOPSWAERO(i,2)
-     PSOLSWAD0AERO(i) = PSOLSW0AERO(i,2)
-     PTOPSWAD0AERO(i) = PTOPSW0AERO(i,2)
-
 ENDIF
 
-
 IF (ok_aie) THEN
+   IF (ok_ade) THEN 
      PSOLSWAIAERO(i) = (ZFSDN_AERO(i,1,4) - ZFSUP_AERO(i,1,4))-(ZFSDN_AERO(i,1,2) - ZFSUP_AERO(i,1,2))
      PTOPSWAIAERO(i) = (ZFSDN_AERO(i,KFLEV+1,4) - ZFSUP_AERO(i,KFLEV+1,4))-(ZFSDN_AERO(i,KFLEV+1,2) - ZFSUP_AERO(i,KFLEV+1,2))
+   ELSE 
+     PSOLSWAIAERO(i) = (ZFSDN_AERO(i,1,5) - ZFSUP_AERO(i,1,5))-(ZFSDN_AERO(i,1,3) - ZFSUP_AERO(i,1,3))
+     PTOPSWAIAERO(i) = (ZFSDN_AERO(i,KFLEV+1,5) - ZFSUP_AERO(i,KFLEV+1,5))-(ZFSDN_AERO(i,KFLEV+1,3) - ZFSUP_AERO(i,KFLEV+1,3))
+   ENDIF
 ENDIF
 
-  ENDDO
+ENDDO
+
 END SUBROUTINE SW_AEROAR4
Index: LMDZ5/branches/testing/libf/phylmd/thermcell.h
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/thermcell.h	(revision 1665)
+++ LMDZ5/branches/testing/libf/phylmd/thermcell.h	(revision 1669)
@@ -1,7 +1,14 @@
       integer            :: iflag_thermals,nsplit_thermals
+
+!!! nrlmd le 10/04/2012
+      integer            :: iflag_trig_bl,iflag_clos_bl
+      integer            :: tau_trig_shallow,tau_trig_deep
+      real               :: s_trig
+!!! fin nrlmd le 10/04/2012
+
       real,parameter     :: r_aspect_thermals=2.,l_mix_thermals=30.
       real               :: alp_bl_k
       real               :: tau_thermals
-      integer,parameter  :: w2di_thermals=1
+      integer,parameter  :: w2di_thermals=0
       integer            :: isplit
 
@@ -14,3 +21,10 @@
       common/ctherm5/iflag_thermals_ed,iflag_thermals_optflux
 
+!!! nrlmd le 10/04/2012
+      common/ctherm6/iflag_trig_bl,iflag_clos_bl
+      common/ctherm7/tau_trig_shallow,tau_trig_deep
+      common/ctherm8/s_trig
+!!! fin nrlmd le 10/04/2012
+
 !$OMP THREADPRIVATE(/ctherm1/,/ctherm2/,/ctherm4/,/ctherm5/)
+!$OMP THREADPRIVATE(/ctherm6/,/ctherm7/,/ctherm8/)
